program Himage

  use sep

  implicit none

  integer                              :: n1, n2, n3, itry1, itry2, v
  real                                 :: o1, d1, o2, d2, o3, d3
  real, dimension(:,:,:), allocatable  :: true, init, lb, ub

  call sep_init()

  call from_history("n1", n1)
  call from_history("o1", o1)
  call from_history("d1", d1)
  call from_history("n2", n2, 1)
  call from_history("o2", o2, 0.)
  call from_history("d2", d2, 1.)
  call from_history("n3", n3, 1)
  call from_history("o3", o3, 0.)
  call from_history("d3", d3, 1.)

  call from_param("v", v, 0)

  call to_history("n1", n1, "lb")
  call to_history("o1", o1, "lb")
  call to_history("d1", d1, "lb")
  call to_history("n2", n2, "lb")
  call to_history("o2", o2, "lb")
  call to_history("d2", d2, "lb")
  call to_history("n3", n3, "lb")
  call to_history("o3", o3, "lb")
  call to_history("d3", d3, "lb")

  call to_history("n1", n1)
  call to_history("o1", o1)
  call to_history("d1", d1)
  call to_history("n2", n2)
  call to_history("o2", o2)
  call to_history("d2", d2)
  call to_history("n3", n3)
  call to_history("o3", o3)
  call to_history("d3", d3)

  allocate(true(n1,n2,n3))
  allocate(init(n1,n2,n3))
  allocate(lb(n1,n2,n3))
  allocate(ub(n1,n2,n3))
  true = 0.
  init = 0.
  lb = 0.
  ub = 0.

  call sep_read(true)
  call sep_read(init, "init")

  if(v .eq. 0) then
    do itry1=0,100
      lb = init*(1.-0.01*itry1)
      if(minval(true-lb) >= 0.) exit
    end do

    do itry2=0,100
      ub = init*(1.+0.01*itry2)
      if(minval(ub-true) >= 0.) exit
    end do
    write(0,*) "lb and ub scales are", 1.-0.01*itry1, 1.+0.01*itry2
  else
    lb = true*(1.-0.01*v)
    ub = true*(1.+0.01*v)
    write(0,*) "lb and ub scales are", 1.-0.01*v, 1.+0.01*v
  end if

  where(lb < minval(true)) lb = minval(true)
  where(ub > maxval(true)) ub = maxval(true)

  call sep_write(lb, "lb")
  call sep_write(ub)

  call sep_close()
end program
