module escat_refl_mod

  implicit none

  integer, private                         :: n1, n2, nt, ntau, otau, it, itau, tau, ix, iz
  real, dimension(:,:,:), pointer, private :: refl

  contains

  subroutine escat_refl_init(n1_in, n2_in, nt_in, ntau_in, otau_in, refl_in)
    integer                        :: n1_in, n2_in, nt_in, ntau_in, otau_in
    real, dimension(:,:,:), target :: refl_in
    n1 = n1_in
    n2 = n2_in
    nt = nt_in
    ntau = ntau_in
    otau = otau_in
    refl => refl_in
  end subroutine

  function escat_refl_op(adj, add, model, data) result(stat)
    logical,intent(in) :: adj, add
    real,dimension(:)  :: model, data
    integer            :: stat
    call escat_refl_op2(adj, add, model, data)
    stat=0
  end function

  subroutine escat_refl_op2(adj, add, model, data)
    logical,intent(in)          :: adj, add 
    real, dimension(n1,n2,nt)   :: model
    real, dimension(n1,n2,nt) :: data
    if(adj) then
      if(.not. add) model = 0.
      do itau=1,ntau
        tau = itau - 1 + otau
        do it=1+abs(tau),nt-abs(tau)
          model(:,:,it-tau) = model(:,:,it-tau) + refl(:,:,itau)*data(:,:,it+tau)
        end do
      end do
    else
      if(.not. add) data = 0.
      do itau=1,ntau
        tau = itau - 1 + otau
        do it=1+abs(tau),nt-abs(tau)
          data(:,:,it+tau) = data(:,:,it+tau) + refl(:,:,itau)*model(:,:,it-tau)
        end do
      end do
    end if
  end subroutine

end module
