module escatr0_mod

  implicit none

  integer, private                         :: n1, n2, nt, ntau, otau, it, itau, tau, ix, iz
  real, dimension(:,:,:), pointer, private :: wfldr0

  contains

  subroutine escatr0_init(n1_in, n2_in, nt_in, ntau_in, otau_in, wfldr0_in)
    integer                        :: n1_in, n2_in, nt_in, ntau_in, otau_in
    real, dimension(:,:,:), target :: wfldr0_in
    n1 = n1_in
    n2 = n2_in
    nt = nt_in
    ntau = ntau_in
    otau = otau_in
    wfldr0 => wfldr0_in
  end subroutine

  function escatr0_op(adj, add, model, data) result(stat)
    logical,intent(in) :: adj, add
    real,dimension(:)  :: model, data
    integer            :: stat
    call escatr0_op2(adj, add, model, data)
    stat=0
  end function

  subroutine escatr0_op2(adj, add, model, data)
    logical,intent(in)          :: adj, add 
    real, dimension(n1,n2,ntau)   :: model
    real, dimension(n1,n2,nt) :: data
    if(adj) then
      if(.not. add) model = 0.
      do itau=1,ntau
        tau = itau - 1 + otau
        do it=1+abs(tau),nt-abs(tau)
          model(:,:,itau) = model(:,:,itau) + data(:,:,it+tau)*wfldr0(:,:,it-tau)
        end do
      end do
    else
      if(.not. add) data = 0.
      do itau=1,ntau
        tau = itau - 1 + otau
        do it=1+abs(tau),nt-abs(tau)
          data(:,:,it+tau) = data(:,:,it+tau) + model(:,:,itau)*wfldr0(:,:,it-tau)
        end do
      end do
    end if
  end subroutine

end module
