module escats0_mod

  implicit none

  integer, private                         :: n1, n2, nt, ntau, otau, it, itau, tau, ix, iz
  real, dimension(:,:,:), pointer, private :: wflds0

  contains

  subroutine escats0_init(n1_in, n2_in, nt_in, ntau_in, otau_in, wflds0_in)
    integer                        :: n1_in, n2_in, nt_in, ntau_in, otau_in
    real, dimension(:,:,:), target :: wflds0_in
    n1 = n1_in
    n2 = n2_in
    nt = nt_in
    ntau = ntau_in
    otau = otau_in
    wflds0 => wflds0_in
  end subroutine

  function escats0_op(adj, add, model, data) result(stat)
    logical,intent(in) :: adj, add
    real,dimension(:)  :: model, data
    integer            :: stat
    call escats0_op2(adj, add, model, data)
    stat=0
  end function

  subroutine escats0_op2(adj, add, model, data)
    logical,intent(in)          :: adj, add 
    real, dimension(n1,n2,ntau)   :: model
    real, dimension(n1,n2,nt) :: data
    if(adj) then
      if(.not. add) model = 0.
      do itau=1,ntau
        tau = itau - 1 + otau
        do it=1+abs(tau),nt-abs(tau)
          model(:,:,itau) = model(:,:,itau) + data(:,:,it+tau)*wflds0(:,:,it-tau)
        end do
      end do
    else
      if(.not. add) data = 0.
      do itau=1,ntau
        tau = itau - 1 + otau
        do it=1+abs(tau),nt-abs(tau)
          data(:,:,it+tau) = data(:,:,it+tau) + model(:,:,itau)*wflds0(:,:,it-tau)
        end do
      end do
    end if
  end subroutine

end module
